/*-
 * Copyright (c) 2003, Patrick MARIE <mycroft@virgaria.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $FreeBSD$
 */
#ifndef _DIVERTD_H_
#define _DIVERTD_H_

#define LIST_SIZE	256
#define HASH_SIZE	16

#define HASH(x) ((((x) >> HASH_SIZE) ^ (x % (1 << HASH_SIZE))) % LIST_SIZE)

#define CONFIG_FILE "/etc/diverd.conf"
#define DUMP_FILE	"/var/run/divertd.dump"

/* checkoption returning values: */
#define EUNKNOW -1
#define ESYNTAX -2

#define TDIVERT 1
#define TREJECT 2

#define DEFAULT_NUM_DIVERT 32
#define DEFAULT_NUM_REJECT 64

#define DEFAULT_TO_NORMAL 301	/* Nmap is not cool. */
#define DEFAULT_TO_DIVERT 3600
#define DEFAULT_TO_REJECT 86400

typedef struct configop_t {
	char           *name;
	int             opcode;
	int             arg;
}               configop;

typedef struct _ahost {
	struct _ahost  *next;
	struct _ahost  *prev;
	struct in_addr  addr;
	time_t          timestamp;
	unsigned short  counter;
	unsigned short  fwrule_div;
	unsigned short  fwrule_rej;
}               ahost;

typedef struct _alist {
	ahost           hastlist[LIST_SIZE];
	ahost          *addrlist[1 << HASH_SIZE];	/* ptr vers hashlist */
}               alist;

#endif
